--------------------------------------------------------------------------------
-- Utilities
--------------------------------------------------------------------------------

{-# LANGUAGE DataKinds #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE GADTs     #-}

module Auxiliary.Utils ( module Auxiliary.Utils, module GHC.TypeLits ) where

import GHC.TypeLits

--------------------------------------------------------------------------------
-- Peano naturals
--------------------------------------------------------------------------------

-- data Nat     -- imported

--------------------------------------------------------------------------------
-- Type-level strings
--------------------------------------------------------------------------------

-- data Symbol  -- imported

--------------------------------------------------------------------------------
-- Useful indices
--------------------------------------------------------------------------------

data Bot
data Top = TT

data Const a (b :: k) = Const { unConst :: a }

--------------------------------------------------------------------------------
-- Kind-polymorphic proxy type
--------------------------------------------------------------------------------

data Proxy (d :: k) = Proxy

--------------------------------------------------------------------------------
-- Type equality
--------------------------------------------------------------------------------

data TEq a b where TRefl :: TEq a a

--------------------------------------------------------------------------------
-- NoPar
--------------------------------------------------------------------------------

data NoPar
