--------------------------------------------------------------------------------
-- From Structured to Deriving
--------------------------------------------------------------------------------

{-# LANGUAGE GADTs                  #-}
{-# LANGUAGE FlexibleContexts       #-}
{-# LANGUAGE FlexibleInstances      #-}
{-# LANGUAGE RankNTypes             #-}
{-# LANGUAGE UndecidableInstances   #-}
{-# LANGUAGE KindSignatures         #-}
{-# LANGUAGE DataKinds              #-}
{-# LANGUAGE MultiParamTypeClasses  #-}
{-# LANGUAGE ScopedTypeVariables    #-}
{-# LANGUAGE OverlappingInstances   #-}
{-# LANGUAGE TypeFamilies           #-}

module Test.S2D0 where

import qualified Library.Structured as S
import qualified Test.Structured    as S
import qualified Library.Deriving   as D
import Conversion.S2D0


--------------------------------------------------------------------------------
-- Tests
--------------------------------------------------------------------------------

instance D.GEq S.Choice

test = let choices = [S.A, S.B, S.C, S.D]
       in [ D.geq x y | x <- choices, y <- choices ]
